<template>
  <div>
    <a-form>
      <a-tabs v-model="tabName" type="card">
        <a-tab-pane
            :tab="$t('functional-analysis.add-modal.required-add')"
            key="addRequire">
          <HotTable
              ref="addRequire"
              key="addRequire"
              v-if="tabName === 'addRequire'"
              :formData="requireData"
              :headers="headers"
              :columns="columns"
              :focusCol="focusCol"
              @formDataChange="functionDataChange"
          />
        </a-tab-pane>
      </a-tabs>
    </a-form>
    <div slot="footer" class="mt10 text-right">
      <a-button @click="closeModal">
        {{ $t('global-btn.cancel') }}
      </a-button>
      <a-button
          type="primary"
          class="ml10"
          @click="save()"
          :loading="saveLoading"
          v-preventReClick>
        {{ $t('global-btn.confirm') }}
      </a-button>
    </div>
  </div>
</template>
<script>

import HotTable from "@/components/HotTable";
import AddDFMEALibrary from "./components/AddDFMEALibrary";
import {checkHotTableLength} from "@/utils/validate";

export default {
  name: "AddRequire",
  components: {
    HotTable,
    AddDFMEALibrary
  },
  props: {
    struTypeCode: {
      default: '',
      type: String
    },
    checkedNode: {
      type: Object
    }
  },
  data() {
    return {
      requireData: [], // 添加要求
      DFMEALibraryData: [], // 添加DFMEA库
      tabName: "addRequire",
      columns: [
        {data: "name", type: "text"},
      ],
      headers: [this.$t('functional-analysis.add-modal.require')],
      focusCol: 0,
      saveLoading: false,
      selectType: 1
    };
  },
  methods: {
    /**
     * 接受子组件handsontable数据
     */
    functionDataChange(val) {
      this.requireData = val;
    },
    /**
     * 接受子组件DFMEA库数据
     */
    DFMEALibraryDataChange(val) {
      this.DFMEALibraryData = val;
    },
    /**
     * 关闭模态框
     */
    closeModal() {
      this.$emit("closeModal");
    },
    /**
     * 刷新右侧结构树
     */
    initRightTree() {
      this.$emit("initRightTree");
    },
    /**
     * 保存
     */
    save() {
      let _that = this;
      if (_that.tabName === 'addRequire') { // 要求添加：保存
        _that.saveRequire();
      } else if (_that.tabName === 'addDFMEALibrary') { // DFMEA库选择：保存
        _that.saveMFMEALibrary();
      }
    },
    /**
     * 构建：要求数据
     */
    buildRequireData() {
      return this.requireData.map((item) => {
        return {name: item.name, code: item.code}
      }).filter((item) => {
        return item.name;
      });
    },
    /**
     * 校验：要求数据
     */
    validateRequireData(requireData) {
      if (requireData && requireData.length > 0) {
        let flag = true;
        requireData.some((item, idx) => {
          if (checkHotTableLength(item.name, 1000)) {
            this.$message.warning(this.$t('global-message.warn.require-name-length', [idx + 1]));
            flag = false
            return true;
          }
        });
        return flag;
      } else {
        this.$message.warning(this.$t('global-message.warn.please-enter-not-name-line'))
        return false;
      }
    },
    /**
     * 保存：要求
     */
    saveRequire() {
      let _that = this;
      // 构建数据
      let requireData = _that.buildRequireData();
      // 校验
      if (!_that.validateRequireData(requireData)) return;
      _that.saveLoading = true; // 开启：加载中...
      _that.$api.saveRequire({
        fmeaId: _that.$store.getters.rfmeaId,
        struId: _that.checkedNode.id,
        struTypeCode: _that.struTypeCode,
        mfmeaStruInputModels: requireData,
      }).then((res) => {
        if (res.flag) {
          // 添加成功，关闭弹窗，刷新右侧树
          _that.$message.success(res.message, 1);
          _that.closeModal();
          _that.initRightTree();
        } else {
          _that.$message.error(res.message, 1);
        }
      }).catch((error) => {
        _that.$message.error(error.response.data.message,1);
      }).finally(() => {
        _that.saveLoading = false; // 关闭：加载中...
      })
    },
    /**
     * 校验：DFAME库选择
     */
    validateDFMEALibraryData() {
      let _that = this;
      if (_that.DFMEALibraryData.length === 0) {
        _that.$message.warning(this.$t('global-message.warn.please-select-node'));
        return false;
      }
      return true;
    },
  }
};
</script>
<style lang="less">

</style>
